local ruleIndex = 1
local specGroupMod = 0

StaticPopupDialogs["TALENTSWITCH_DELETE"] = {
  text = "Are you sure you want to delete this rule?",
  button1 = "Yes",
  button2 = "No",
  OnAccept = function()
      TalentSwitch.saveRule(nil, nil)
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

TSwitchUIframe = CreateFrame("Frame", "TalentSwitchFame", UIParent)
TSwitchUIframe:Hide()
TSwitchUIframe:SetPoint("CENTER", "UIParent", "CENTER")
TSwitchUIframe:SetWidth(900)
TSwitchUIframe:SetHeight(600)
TSwitchUIframe:SetFrameStrata("DIALOG")
TSwitchUIframe:SetToplevel(true)
TSwitchUIframe:SetMovable(true)
TSwitchUIframe:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 32, edgeSize = 16,
		insets = { left = 5, right = 5, top = 5, bottom = 5 }
	})
TSwitchUIframe:SetBackdropColor(0,0,0, 0.95)
table.insert(UISpecialFrames, "TalentSwitchTSwitchUIframe") -- make TSwitchUIframes Esc Sensitive by default
TSwitchUIframe.Drag = CreateFrame("Button", "", TSwitchUIframe)
TSwitchUIframe.Drag:SetPoint("TOPLEFT", TSwitchUIframe, "TOPLEFT", 10,-5)
TSwitchUIframe.Drag:SetPoint("TOPRIGHT", TSwitchUIframe, "TOPRIGHT", -10,-5)
TSwitchUIframe.Drag:SetHeight(22)
TSwitchUIframe.Drag:SetNormalTexture("Interface\\FriendsFrame\\UI-FriendsFrame-HighlightBar")
TSwitchUIframe.Drag:SetHighlightTexture("Interface\\FriendsFrame\\UI-FriendsFrame-HighlightBar")
TSwitchUIframe.Drag:SetScript("OnMouseDown", function() TSwitchUIframe:StartMoving() end)
TSwitchUIframe.Drag:SetScript("OnMouseUp", function() TSwitchUIframe:StopMovingOrSizing() end)
TSwitchUIframe.Drag:SetText("TalentSwitch - Custom Macro Substitution Rules (Active specialisation)")
TSwitchUIframe.Drag:SetNormalFontObject("GameFontHighlightHuge")

TSwitchUIframe.Done = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")
TSwitchUIframe.Done:SetPoint("BOTTOMRIGHT", TSwitchUIframe, "BOTTOMRIGHT", -10, 10)
TSwitchUIframe.Done:SetScript("OnClick", function() TSwitchUIframe:Hide() end)
TSwitchUIframe.Done:SetText("Done")

TSwitchUIframe.Help = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")
TSwitchUIframe.Help:SetPoint("BOTTOMRIGHT", TSwitchUIframe, "BOTTOMRIGHT", -110, 10)
TSwitchUIframe.Help:SetScript("OnClick", function() SlashCmdList.TSWITCHTUT() TSwitchTut:Raise() end)
TSwitchUIframe.Help:SetText("Help")

TSwitchUIframe.Rule = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")
TSwitchUIframe.Rule:SetPoint("BOTTOMLEFT", TSwitchUIframe, "BOTTOM", 0, 10)
TSwitchUIframe.Rule:SetText("New rule")
TSwitchUIframe.Rule:Disable()

TSwitchUIframe.Save = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")
TSwitchUIframe.Save:SetPoint("BOTTOMLEFT", TSwitchUIframe, "BOTTOM", -100, 10)
TSwitchUIframe.Save:SetText("Save")
TSwitchUIframe.Save:SetWidth(100)
TSwitchUIframe.Save:Disable()

TSwitchUIframe.Delete = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")
TSwitchUIframe.Delete:SetPoint("BOTTOMLEFT", TSwitchUIframe, "BOTTOM", 90, 10)
TSwitchUIframe.Delete:SetText("Delete")
TSwitchUIframe.Delete:SetWidth(100)
TSwitchUIframe.Delete:Disable()

TSwitchUIframe.Spec = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")
TSwitchUIframe.Spec:SetPoint("BOTTOMLEFT", TSwitchUIframe, "BOTTOM", -100, 30)
TSwitchUIframe.Spec:SetText("Specialisation")
TSwitchUIframe.Spec:SetWidth(100)
TSwitchUIframe.Spec:SetScript("OnClick", function() TalentSwitch.specSelect(nil,0) end)
TSwitchUIframe.Spec:Enable()

TSwitchUIframe.Copy = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")
TSwitchUIframe.Copy:SetPoint("BOTTOMLEFT", TSwitchUIframe, "BOTTOM", 0, 30)
TSwitchUIframe.Copy:SetWidth(190)
TSwitchUIframe.Copy:SetText("Copy to other specialisation")
TSwitchUIframe.Copy:Disable()

TSwitchUIframe.Tier = {}
for i = 1,6 do
	TSwitchUIframe.Tier[i] = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")

	local offset = -90*i

	TSwitchUIframe.Tier[i]:SetPoint("BOTTOMLEFT", TSwitchUIframe, "TOPLEFT", 10, offset)
	TSwitchUIframe.Tier[i]:SetScript("OnClick", function() TalentSwitch.tierSelect(i) end)
	TSwitchUIframe.Tier[i]:SetText("Tier "..i)
	local buttonWidth = TSwitchUIframe.Tier[i]:GetFontString():GetWidth() + 15
	if ( buttonWidth > 160 ) then buttonWidth = 160 end
	if ( buttonWidth < 90 ) then buttonWidth = 90 end
	TSwitchUIframe.Tier[i]:SetWidth(buttonWidth)
end

TSwitchUIframe.Talents = {}
for i = 1,3 do
	TSwitchUIframe.Talents[i] = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")

	TSwitchUIframe.Talents[i]:SetText("")
	local buttonWidth = TSwitchUIframe.Talents[i]:GetFontString():GetWidth() + 15
	if ( buttonWidth > 260 ) then buttonWidth = 260 end
	if ( buttonWidth < 90 ) then buttonWidth = 90 end

	local offset = (750-buttonWidth) * (i-1) / 2 + 120 + buttonWidth/2

	TSwitchUIframe.Talents[i]:SetPoint("BOTTOM", TSwitchUIframe, "TOPLEFT", offset, -50)
	TSwitchUIframe.Talents[i]:SetScript("OnClick", function() TalentSwitch.talentSelect(nil, 0) end)

	TSwitchUIframe.Talents[i]:SetWidth(buttonWidth)
end


TSwitchUIframe.EditBox1 = CreateFrame("EditBox", "", TSwitchUIframe)
TSwitchUIframe.EditBox1:SetMultiLine(true)
TSwitchUIframe.EditBox1:SetPoint("TOPLEFT", TSwitchUIframe, "TOPLEFT", 120, -157)
TSwitchUIframe.EditBox1:SetText("New rule")
TSwitchUIframe.EditBox1:SetWidth(370)
TSwitchUIframe.EditBox1:SetHeight(52)
TSwitchUIframe.EditBox1:SetAutoFocus(false)
TSwitchUIframe.EditBox1:SetHitRectInsets(-1,-1,-1,-1)
TSwitchUIframe.EditBox1:SetTextInsets(6,6,6,6)
TSwitchUIframe.EditBox1:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 32, edgeSize = 16,
		insets = { left = 5, right = 5, top = 5, bottom = 5 }
	})
TSwitchUIframe.EditBox1:SetBackdropColor(0,0,0, 0.95)
TSwitchUIframe.EditBox1:SetFontObject("GameFontHighlight")
TSwitchUIframe.EditBox1:SetMaxLetters(255)
TSwitchUIframe.EditBox1:Hide()

TSwitchUIframe.EditBox2 = CreateFrame("EditBox", "", TSwitchUIframe)
TSwitchUIframe.EditBox2:SetMultiLine(true)
TSwitchUIframe.EditBox2:SetPoint("TOPLEFT", TSwitchUIframe, "TOPLEFT", 500, -157)
TSwitchUIframe.EditBox2:SetText("New rule")
TSwitchUIframe.EditBox2:SetWidth(370)
TSwitchUIframe.EditBox2:SetHeight(52)
TSwitchUIframe.EditBox2:SetAutoFocus(false)
TSwitchUIframe.EditBox2:SetHitRectInsets(-1,-1,-1,-1)
TSwitchUIframe.EditBox2:SetTextInsets(6,6,6,6)
TSwitchUIframe.EditBox2:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = true, tileSize = 32, edgeSize = 16,
		insets = { left = 5, right = 5, top = 5, bottom = 5 }
	})
TSwitchUIframe.EditBox2:SetBackdropColor(0,0,0, 0.95)
TSwitchUIframe.EditBox2:SetFontObject("GameFontHighlight")
TSwitchUIframe.EditBox2:SetMaxLetters(255)
TSwitchUIframe.EditBox2:Hide()


TSwitchUIframe.previous = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")
TSwitchUIframe.previous:SetPoint("BOTTOMRIGHT", TSwitchUIframe, "TOPRIGHT", -115, -90)
TSwitchUIframe.previous:SetScript("OnClick", function() TalentSwitch.talentSelect(nil, 0) end)
TSwitchUIframe.previous:SetText("<")
TSwitchUIframe.previous:SetWidth(45)

TSwitchUIframe.next = CreateFrame("Button", "", TSwitchUIframe, "OptionsButtonTemplate")
TSwitchUIframe.next:SetPoint("BOTTOMRIGHT", TSwitchUIframe, "TOPRIGHT", -10, -90)
TSwitchUIframe.next:SetScript("OnClick", function() TalentSwitch.talentSelect(nil, 0) end)
TSwitchUIframe.next:SetText(">")
TSwitchUIframe.next:SetWidth(45)

TSwitchUIframe.guideText = CreateFrame("Frame", "", TSwitchUIframe);
TSwitchUIframe.guideText:ClearAllPoints();
TSwitchUIframe.guideText:SetHeight(20);
TSwitchUIframe.guideText:SetWidth(600);
TSwitchUIframe.guideText.text = TSwitchUIframe.guideText:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont");
TSwitchUIframe.guideText.text:SetAllPoints();
TSwitchUIframe.guideText:SetPoint("CENTER", 0, 200);
TSwitchUIframe.guideText.text:SetText("")


TSwitchUIframe.guideTextL = CreateFrame("Frame", "", TSwitchUIframe);
TSwitchUIframe.guideTextL:ClearAllPoints();
TSwitchUIframe.guideTextL:SetHeight(20);
TSwitchUIframe.guideTextL:SetWidth(300);
TSwitchUIframe.guideTextL.text = TSwitchUIframe.guideTextL:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont");
TSwitchUIframe.guideTextL.text:SetAllPoints();
TSwitchUIframe.guideTextL:SetPoint("TOPLEFT", TSwitchUIframe, "TOPLEFT", 120, -137)
TSwitchUIframe.guideTextL.text:SetText("Change:")

TSwitchUIframe.guideTextR = CreateFrame("Frame", "", TSwitchUIframe);
TSwitchUIframe.guideTextR:ClearAllPoints();
TSwitchUIframe.guideTextR:SetHeight(20);
TSwitchUIframe.guideTextR:SetWidth(300);
TSwitchUIframe.guideTextR.text = TSwitchUIframe.guideTextR:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont");
TSwitchUIframe.guideTextR.text:SetAllPoints();
TSwitchUIframe.guideTextR:SetPoint("TOPLEFT", TSwitchUIframe, "TOPLEFT", 500, -137)
TSwitchUIframe.guideTextR.text:SetText("To:")

TSwitchUIframe.guideTextI = CreateFrame("Frame", "", TSwitchUIframe);
TSwitchUIframe.guideTextI:ClearAllPoints();
TSwitchUIframe.guideTextI:SetHeight(20);
TSwitchUIframe.guideTextI:SetWidth(40);
TSwitchUIframe.guideTextI.text = TSwitchUIframe.guideTextI:CreateFontString(nil, "BACKGROUND", "PVPInfoTextFont");
TSwitchUIframe.guideTextI.text:SetAllPoints();
TSwitchUIframe.guideTextI:SetPoint("BOTTOMRIGHT", TSwitchUIframe, "TOPRIGHT", -65, -90)
TSwitchUIframe.guideTextI.text:SetText("X")

TSwitchUIframe.guideTextL:Hide()
TSwitchUIframe.guideTextR:Hide()
TSwitchUIframe.guideTextI:Hide()

TSwitchUIframe.next:Hide()
TSwitchUIframe.previous:Hide()

-- functions
function TalentSwitch.specSelect(talent, dir)
	specGroupMod = 1 - specGroupMod
	
	if specGroupMod == 1 then
		TSwitchUIframe.Drag:SetText("TalentSwitch - Custom Macro Substitution Rules (Inactive specialisation)")
	else
		TSwitchUIframe.Drag:SetText("TalentSwitch - Custom Macro Substitution Rules (Active specialisation)")
	end

	if talent==nil then
		return
	else
		TalentSwitch.talentSelect(talent, dir)
	end
end

function TalentSwitch.tierSelect(index)

	local talents = {{},{},{},{},{},{}}
	for i = 1, MAX_NUM_TALENTS do
		local name, iconTexture, tier, column, selected, available = GetTalentInfo(i)

		if tier ~= nil and tier <= 7 and tier >= 0 then
			table.insert(talents[tier], name)
		else
			print(GetTalentInfo(i))
		end
	end

	local maxButtonWidth = 0
	
	for i = 1,3 do
		TSwitchUIframe.Talents[i]:SetText(talents[index][i])
		TSwitchUIframe.Talents[i]:SetScript("OnClick", function() TalentSwitch.talentSelect(talents[index][i], 0) end)

		local buttonWidth = TSwitchUIframe.Talents[i]:GetFontString():GetWidth() + 15
		if ( buttonWidth > 260 ) then buttonWidth = 260 end
		if ( buttonWidth < 90 ) then buttonWidth = 90 end
		if buttonWidth > maxButtonWidth then maxButtonWidth = buttonWidth end
	end

	for i = 1,3 do
		local offset = (750-maxButtonWidth) * (i-1) / 2 + 120 + maxButtonWidth/2
		TSwitchUIframe.Talents[i]:SetWidth(maxButtonWidth)
		TSwitchUIframe.Talents[i]:SetPoint("BOTTOM", TSwitchUIframe, "TOPLEFT", offset, -50)

	end

	TSwitchUIframe.EditBox1:Hide()
	TSwitchUIframe.EditBox2:Hide()
	TSwitchUIframe.next:Hide()
	TSwitchUIframe.previous:Hide()
	TSwitchUIframe.guideText:Hide()
	TSwitchUIframe.guideTextL:Hide()
	TSwitchUIframe.guideTextR:Hide()
	TSwitchUIframe.guideTextI:Hide()
	TSwitchUIframe.Save:Disable()
	TSwitchUIframe.Rule:Disable()
	TSwitchUIframe.Delete:Disable()
	TSwitchUIframe.Copy:Disable()

	TSwitchUIframe.next:SetScript("OnClick", function() end)
	TSwitchUIframe.previous:SetScript("OnClick", function() end)
	TSwitchUIframe.Spec:SetScript("OnClick", function() TalentSwitch.specSelect(nil,0) end)

end

function TalentSwitch.talentSelect(talent, dir)

	if talent == nil then return end

	local specGroup = GetActiveSpecGroup()
	if specGroupMod == 1 then
		specGroup = 3 - specGroup
	end

	TSwitchUIframe.Spec:SetScript("OnClick", function() TalentSwitch.specSelect(talent,0) end)

	if dir ==0 then
		ruleIndex = 1
		TSwitchUIframe.next:SetScript("OnClick", function() TalentSwitch.talentSelect(talent, 1) end)
		TSwitchUIframe.previous:SetScript("OnClick", function() TalentSwitch.talentSelect(talent, 2) end)
		TSwitchUIframe.guideText.text:SetText("When I select '"..talent.."'")
		TSwitchUIframe.guideText:Show()
		TSwitchUIframe.Rule:SetScript("OnClick", function() TalentSwitch.newRule(talent) end)

	elseif dir == 1 then
		ruleIndex = ruleIndex + 1

	elseif dir == 2 then
		ruleIndex = ruleIndex - 1

	elseif dir == 3 then
		ruleIndex = 0

	elseif dir == 4 then
		ruleIndex = #custom[specGroup][talent] or 0
	else
		return
	end

	TSwitchUIframe.Copy:SetScript("OnClick", function() TalentSwitch.copyRule(talent) end)
	TSwitchUIframe.Save:SetScript("OnClick", function() TalentSwitch.saveRule(talent, ruleIndex) end)
	TSwitchUIframe.Delete:SetScript("OnClick", function() TalentSwitch.delRule(talent, ruleIndex) end)

	TSwitchUIframe.guideTextI.text:SetText(ruleIndex)

	TSwitchUIframe.EditBox1:SetScript("OnMouseDown", function() end)
	TSwitchUIframe.EditBox2:SetScript("OnMouseDown", function() end)

	if ruleIndex == 0 then
		TSwitchUIframe.EditBox1:SetText("(Enter macro text to remove for this talent here!)")	
		TSwitchUIframe.EditBox2:SetText("(Enter macro text to subsitute in for this talent here!)")

		TSwitchUIframe.EditBox1:SetScript("OnMouseDown", TalentSwitch.clearEdit)
		TSwitchUIframe.EditBox2:SetScript("OnMouseDown", TalentSwitch.clearEdit)

		TSwitchUIframe.EditBox1:Show()
		TSwitchUIframe.EditBox2:Show()

		TSwitchUIframe.next:Show()
		TSwitchUIframe.previous:Show()

		TSwitchUIframe.guideTextL:Show()
		TSwitchUIframe.guideTextR:Show()
		TSwitchUIframe.guideTextI:Show()

		TSwitchUIframe.Save:Disable()
		TSwitchUIframe.Copy:Disable()
		TSwitchUIframe.Rule:Enable()
		TSwitchUIframe.Delete:Disable()
		if custom[specGroup][talent] == nil or custom[specGroup][talent][ruleIndex+1] == nil then
			TSwitchUIframe.next:Disable()
		else
			TSwitchUIframe.next:Enable()
		end
		TSwitchUIframe.previous:Disable()
	
	elseif custom[specGroup][talent]~= nil and custom[specGroup][talent][ruleIndex] ~= nil then
		local a = custom[specGroup][talent][ruleIndex][1]
		local b = custom[specGroup][talent][ruleIndex][2]

		TSwitchUIframe.EditBox1:SetText(a)	
		TSwitchUIframe.EditBox2:SetText(b)

		TSwitchUIframe.EditBox1:Show()
		TSwitchUIframe.EditBox2:Show()

		TSwitchUIframe.next:Show()
		TSwitchUIframe.previous:Show()

		TSwitchUIframe.guideTextL:Show()
		TSwitchUIframe.guideTextR:Show()
		TSwitchUIframe.guideTextI:Show()

		TSwitchUIframe.Save:Enable()
		TSwitchUIframe.Rule:Enable()
		TSwitchUIframe.Delete:Enable()
		TSwitchUIframe.Copy:Enable()

		if custom[specGroup][talent][ruleIndex-1] == nil then
			TSwitchUIframe.previous:Disable()
		else
			TSwitchUIframe.previous:Enable()
		end
		if custom[specGroup][talent][ruleIndex+1] == nil then
			TSwitchUIframe.next:Disable()
		else
			TSwitchUIframe.next:Enable()
		end
	else
		TSwitchUIframe.EditBox1:Hide()
		TSwitchUIframe.EditBox2:Hide()

		TSwitchUIframe.next:Hide()
		TSwitchUIframe.previous:Hide()

		TSwitchUIframe.guideTextL:Hide()
		TSwitchUIframe.guideTextR:Hide()
		TSwitchUIframe.guideTextI:Hide()

		TSwitchUIframe.Save:Disable()
		TSwitchUIframe.Rule:Enable()
		TSwitchUIframe.Delete:Disable()	
		TSwitchUIframe.Copy:Disable()
	end

end

function TalentSwitch.newRule(talent)
	TalentSwitch.talentSelect(talent, 3)
end

function TalentSwitch.saveRule(talent, index)
	if index ~=0 then
		StaticPopupDialogs["TALENTSWITCH_DELETE"].OnAccept = function() TalentSwitch.saveRuleFinal(talent, index) end
		StaticPopupDialogs["TALENTSWITCH_DELETE"].text = "Are you sure you want to save your changes to this rule?"
		StaticPopup_Show ("TALENTSWITCH_DELETE")
	else
		local msg = talent.."&"..TSwitchUIframe.EditBox1:GetText().."&"..TSwitchUIframe.EditBox2:GetText()
		SlashCmdList.TSWITCHCUSTOM(msg, "TSwitchInternal"..specGroupMod)

		TalentSwitch.talentSelect(talent, 4)
	end
end
function TalentSwitch.saveRuleFinal(talent, index)
	local specGroup = GetActiveSpecGroup()
	if specGroupMod == 1 then
		specGroup = 3-specGroup
	end

	custom[specGroup][talent][index][1] = TSwitchUIframe.EditBox1:GetText()
	custom[specGroup][talent][index][2] = TSwitchUIframe.EditBox2:GetText()
end

function TalentSwitch.delRule(talent, index)
	msg = talent.."&"..index

	StaticPopupDialogs["TALENTSWITCH_DELETE"].text = "Are you sure you want to delete this rule?"
	StaticPopupDialogs["TALENTSWITCH_DELETE"].OnAccept = function() SlashCmdList.TSWITCHDEL(msg,"TSwitchInternal"..specGroupMod) end
	StaticPopup_Show ("TALENTSWITCH_DELETE")
end

function TalentSwitch.clearEdit()
	TSwitchUIframe.EditBox1:SetScript("OnMouseDown", function() end)
	TSwitchUIframe.EditBox2:SetScript("OnMouseDown", function() end)
	TSwitchUIframe.EditBox1:SetText("")
	TSwitchUIframe.EditBox2:SetText("")
	TSwitchUIframe.Save:Enable()
end

function TalentSwitch.copyRule(talent)
		local msg = talent.."&"..TSwitchUIframe.EditBox1:GetText().."&"..TSwitchUIframe.EditBox2:GetText()
		local specGroupDeMod = 1 - specGroupMod

		SlashCmdList.TSWITCHCUSTOM(msg, "TSwitchInternal"..specGroupDeMod)

		TalentSwitch.specSelect(talent, 4)
end